org.apache.solr.request

## Interface SolrRequestHandler

- All Superinterfaces:
    SolrInfoMBean
  All Known Implementing Classes:
    AnalysisRequestHandlerBase, BlobHandler, CdcrRequestHandler, CollectionsHandler, ConfigSetsHandler, ContentStreamHandlerBase, CoreAdminHandler, DocumentAnalysisRequestHandler, DumpRequestHandler, FieldAnalysisRequestHandler, FileFloatSource.ReloadCacheRequestHandler, GraphHandler, InfoHandler, LoggingHandler, LukeRequestHandler, MoreLikeThisHandler, NotFoundRequestHandler, PingRequestHandler, PluginInfoHandler, PropertiesRequestHandler, RealTimeGetHandler, ReplicationHandler, RequestHandlerBase, SchemaHandler, SearchHandler, SecurityConfHandler, SegmentsInfoRequestHandler, ShowFileRequestHandler, SolrConfigHandler, SolrInfoMBeanHandler, SQLHandler, StandardRequestHandler, StreamHandler, SystemInfoHandler, ThreadDumpHandler, UpdateRequestHandler, ZookeeperInfoHandler

      public interface SolrRequestHandler
      extends SolrInfoMBean

  Implementations of `SolrRequestHandler` are called to handle query requests. Different `SolrRequestHandler`s are registered with the `SolrCore`. One way to register a SolrRequestHandler with the core is thorugh the `solrconfig.xml` file.

  Example `solrconfig.xml` entry to register a `SolrRequestHandler` implementation to handle all queries with a Request Handler of "/test":

  `<requestHandler name="/test" class="solr.tst.TestRequestHandler" />`

  A single instance of any registered SolrRequestHandler is created via the default constructor and is reused for all relevant queries.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `TYPE`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `handleRequest(SolrQueryRequest req, SolrQueryResponse rsp)` Handles a query request, this method must be thread safe.
    `void` | `init(NamedList args)` `init` will be called just once, immediately after creation.

    - ### Methods inherited from interface org.apache.solr.core.SolrInfoMBean

      `getCategory, getDescription, getDocs, getName, getSource, getStatistics, getVersion`

- - ### Field Detail

    - #### TYPE

          static final String TYPE

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### init

          void init(NamedList args)

      `init` will be called just once, immediately after creation.

      The args are user-level initialization parameters that may be specified when declaring a request handler in solrconfig.xml

    - #### handleRequest

          void handleRequest(SolrQueryRequest req,
                             SolrQueryResponse rsp)

      Handles a query request, this method must be thread safe.

      Information about the request may be obtained from `req` and response information may be set using `rsp`.

      There are no mandatory actions that handleRequest must perform. An empty handleRequest implementation would fulfill all interface obligations.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.